OpenTTD Source: StrongIntegralTypedef< T, Tthis > Struct Template Reference

OpenTTD Source 13.2.1

Public Member Functions
StrongIntegralTypedef< T, Tthis > Struct Template Reference

Extension of StrongTypedef with operators for addition and subtraction. More...

`#include <strong_typedef_type.hpp>`

Inheritance diagram for StrongIntegralTypedef< T, Tthis >:

## Public Member Functions
constexpr Tthis & | operator++ ()
constexpr Tthis & | operator-- ()
constexpr Tthis | operator++ (int)
constexpr Tthis | operator-- (int)
constexpr Tthis & | operator+= (const Tthis &rhs)
constexpr Tthis & | operator-= (const Tthis &rhs)
constexpr Tthis | operator+ (const Tthis &rhs) const
constexpr Tthis | operator- (const Tthis &rhs) const
constexpr Tthis | operator+ (const T &rhs) const
constexpr Tthis | operator- (const T &rhs) const
Public Member Functions inherited from StrongTypedef< T, Tthis >
constexpr | StrongTypedef (const StrongTypedef &o)=default
constexpr | StrongTypedef (StrongTypedef &&o)=default
constexpr | StrongTypedef (const T &value)
constexpr Tthis & | operator= (const StrongTypedef &rhs)
constexpr Tthis & | operator= (StrongTypedef &&rhs)
constexpr Tthis & | operator= (const T &rhs)
constexpr | operator T () const
constexpr bool | operator== (const StrongTypedef &rhs) const
constexpr bool | operator!= (const StrongTypedef &rhs) const
constexpr bool | operator== (const T &rhs) const
constexpr bool | operator!= (const T &rhs) const

## Additional Inherited Members
Public Types inherited from StrongTypedef< T, Tthis >
using | Type = T
Data Fields inherited from StrongTypedef< T, Tthis >
T | value {}
| Backing storage field.

## Detailed Description

### template<class T, class Tthis>
struct StrongIntegralTypedef< T, Tthis >

Extension of StrongTypedef with operators for addition and subtraction.

Template Parameters

  T | Storage type
  Tthis | Type of the derived class (i.e. the concrete usage of this class).

Definition at line 56 of file strong_typedef_type.hpp.

The documentation for this struct was generated from the following file:

- src/core/strong_typedef_type.hpp